function D = MakeHaarDCT(d)
%
% Computes a Haar/DCT dictionary in dimension d
% D = MakeHaarDCT(d)
% - d : signal dimension
% - D : dictionary synthesis matrix (atoms on columns)
% Note: size(D) is d x (2d - 1)
% Pierre Vandergheynst, 2005
% Uses routine haarmtx from the Matlab Central file exchange
% http://www.mathworks.com/matlabcentral/fileexchange/loadCategory.do

disp('computing a Haar/DCT dictionary')
D1 = haarmtx(d); 
D1 = D1'; D1(:,1) = [];% put D1 in synthesis form and remove 1st atom (constant)
D2 = dct(eye(d)); D2 = D2'; 
D = [D1 D2]; 
disp('done');