function Phi = GetPhiFromG(G, d);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get the square root from Gram 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[N n]=size(G);

rank1 = rank(G);
% disp(['rank G = ', num2str(rank1)])
if rank1>d    
%     disp('rank reduction')
    %reduce rank back to d
    [U, S, V]=svd(G);           
    U1=U(:,1:d);
    S1=S(1:d,1:d);
    V1=V(:,1:d);
    
    G=U1*S1*V1';
    
    %normalize Gram: mallon then paizei kapoio rolo
    G = diag(1./sqrt(diag(G)))*G*diag(1./sqrt(diag(G)));
end


%check feasibility
E = eig(G);
E = real(E);
nonfeasible = length(find(E<-1e-4));

if nonfeasible 
    disp([' NON-FEASIBLE!!!!']);   
    D = [];
else
    %disp([' FEASIBLE']);
    [U,S,V]=svd(G);
    D = sqrt(S(1:d,1:d))*U(:,1:d)';
 
%     D = normc(D);
    %mu = GetMutualCoherence(D);
    %disp(['-----------------------------------------------'])
end

Phi = D;



