function [xOMP SS]= SensingOMP(b, Phi, Psi, sparsity);
%solve problem
%   min |x|_0 s.t. |b-Phi*x|_2 <= threshold  
%...
%use a sensing matrix Psi different than the dictionary Phi
%...
%thrOMP = threshold of the residual |b-Phi*x|_2 

disp('Sensing OMP...')

[n m]=size(Phi);

thrOMP=1e-4;
r=b;
SS=[];

i=0;
MAX_ITER=m;%sparsity+1;%
while r'*r>thrOMP,
    i=i+1;
    if i>=MAX_ITER
        disp('Sensing OMP: Maximum number of iterations completed')
        break
    end
    Z=abs(Psi'*r);                      %SENSING: find the support using Psi
    posZ=find(Z==max(Z));               %find the index of the column that gives the maximum residual element
    SS=sort([SS,posZ(1)]);              %save column indexes that are added to the solution
    r=b-Phi(:,SS)*pinv(Phi(:,SS))*b;    %residual    
end;
disp(['OMP ITERATIONS COMPLETED: ', num2str(i)])
xOMP=zeros(m,1);
xOMP(SS)=pinv(Phi(:,SS))*b;