function [xOMP SS] = myOMP(b, A);

%solve problem
%   min |x|_0 s.t. |b-Ax|_2 <= threshold  
%...

%thrOMP = threshold of the residual |b-Ax|_2 

[n m]=size(A);

thrOMP=1e-4;
r=b;
SS=[];

j=0;
while r'*r>thrOMP,
    Z=abs(A'*r);                    %
    posZ=find(Z==max(Z));           %find the index of the column that gives the maximum residual element
    SS=sort([SS,posZ(1)]);          %save column indexes that are added to the solution
    r=b-A(:,SS)*pinv(A(:,SS))*b;    %residual
    j=j+1;
    if j>=m
        break
    end
end;
xOMP=zeros(m,1);
xOMP(SS)=pinv(A(:,SS))*b;